2010-12-02 09:48:02 +11:00
# Hey Emacs, this is a -*- shell-script -*- !!!
2007-06-01 20:54:26 +10:00
# utility functions for ctdb event scripts
2015-08-17 14:01:40 +10:00
if [ -z "$CTDB_BASE" ] ; then
echo 'CTDB_BASE unset in CTDB functions file'
exit 1
fi
2016-06-29 17:33:43 +10:00
export CTDB_BASE
2015-08-17 14:01:40 +10:00
2016-07-06 17:16:44 +10:00
# CTDB_VARDIR is used elsewhere
# shellcheck disable=SC2034
2015-08-13 15:54:20 +10:00
CTDB_VARDIR="/usr/local/var/lib/ctdb"
2016-06-08 12:08:35 +02:00
CTDB="${CTDB:-/usr/local/bin/ctdb}"
2015-08-13 15:17:51 +10:00
# Only (and always) override these variables in test code
2015-08-13 15:54:20 +10:00
if [ -z "$CTDB_SCRIPT_VARDIR" ] ; then
2018-02-06 11:42:26 +11:00
CTDB_SCRIPT_VARDIR="/usr/local/var/lib/ctdb/scripts"
2015-08-13 15:17:51 +10:00
fi
2015-08-17 14:12:15 +10:00
if [ -z "$CTDB_SYS_ETCDIR" ] ; then
CTDB_SYS_ETCDIR="/etc"
2015-08-13 15:17:51 +10:00
fi
2010-12-15 10:08:16 +11:00
2016-02-12 10:12:13 +11:00
if [ -z "$CTDB_HELPER_BINDIR" ] ; then
CTDB_HELPER_BINDIR="/usr/local/libexec/ctdb"
fi
2007-06-03 22:07:07 +10:00
#######################################
# pull in a system config file, if any
2015-11-17 14:57:44 +11:00
2018-02-06 11:25:56 +11:00
load_system_config ()
{
if [ -z "$1" ] ; then
return
2009-11-19 15:00:17 +11:00
fi
2013-05-14 14:56:26 +10:00
2018-02-06 11:25:56 +11:00
if [ -f "${CTDB_SYS_ETCDIR}/sysconfig/$1" ]; then
. "${CTDB_SYS_ETCDIR}/sysconfig/$1"
elif [ -f "${CTDB_SYS_ETCDIR}/default/$1" ]; then
. "${CTDB_SYS_ETCDIR}/default/$1"
fi
}
2009-11-13 18:28:25 +11:00
2018-04-04 19:06:13 +10:00
# load_script_options [ component script ]
# script is an event script name relative to a component
# component is currently ignored
2018-02-19 13:13:26 +11:00
load_script_options ()
{
2018-04-04 19:06:13 +10:00
if [ $# -eq 2 ] ; then
_script="$2"
elif [ $# -eq 0 ] ; then
_script=""
else
die "usage: load_script_options [ component script ]"
fi
2018-04-04 18:52:36 +10:00
_options="${CTDB_BASE}/script.options"
if [ -r "$_options" ] ; then
. "$_options"
fi
2018-04-04 19:06:13 +10:00
if [ -n "$_script" ] ; then
2018-05-15 13:39:15 +10:00
_s="${CTDB_BASE}/events/legacy/${_script}"
2018-04-04 19:06:13 +10:00
else
_s="${0%.script}"
fi
_options="${_s}.options"
2018-02-19 13:13:26 +11:00
if [ -r "$_options" ] ; then
. "$_options"
fi
}
2011-08-17 09:00:46 +10:00
##############################################################
2012-03-07 16:09:56 +11:00
die ()
{
_msg="$1"
_rc="${2:-1}"
2016-04-08 17:14:23 +10:00
echo "$_msg" >&2
2016-07-06 17:31:51 +10:00
exit "$_rc"
2012-03-07 16:09:56 +11:00
}
2012-10-16 17:04:48 +11:00
# Log given message or stdin to either syslog or a CTDB log file
# $1 is the tag passed to logger if syslog is in use.
script_log ()
2012-09-03 15:37:01 +10:00
{
2012-10-16 17:04:48 +11:00
_tag="$1" ; shift
2014-08-11 17:07:41 +10:00
case "$CTDB_LOGGING" in
file:*|"")
if [ -n "$CTDB_LOGGING" ] ; then
_file="${CTDB_LOGGING#file:}"
2012-10-16 17:04:48 +11:00
else
2015-08-17 20:47:58 +10:00
_file="/usr/local/var/log/log.ctdb"
2012-10-16 17:04:48 +11:00
fi
2014-08-11 17:07:41 +10:00
{
if [ -n "$*" ] ; then
echo "$*"
else
cat
fi
} >>"$_file"
;;
*)
2014-08-08 20:59:21 +10:00
# Handle all syslog:* variants here too. There's no tool to do
# the lossy things, so just use logger.
2017-06-22 14:34:36 +10:00
logger -t "ctdbd: ${_tag}" "$@"
2014-08-11 17:07:41 +10:00
;;
esac
2012-10-16 17:04:48 +11:00
}
# When things are run in the background in an eventscript then logging
# output might get lost. This is the "solution". :-)
background_with_logging ()
{
2012-09-03 15:37:01 +10:00
(
"$@" 2>&1 </dev/null |
2013-04-22 13:48:06 +10:00
script_log "${script_name}&"
2012-09-03 15:37:01 +10:00
)&
return 0
}
2011-08-23 16:32:34 +10:00
##############################################################
# check number of args for different events
ctdb_check_args ()
{
case "$1" in
takeip|releaseip)
if [ $# != 4 ]; then
echo "ERROR: must supply interface, IP and maskbits"
exit 1
fi
;;
updateip)
if [ $# != 5 ]; then
echo "ERROR: must supply old interface, new interface, IP and maskbits"
exit 1
fi
;;
esac
}
2009-01-16 13:26:57 +01:00
##############################################################
# determine on what type of system (init style) we are running
2013-10-18 13:24:03 +11:00
detect_init_style()
{
2018-02-19 15:29:43 +11:00
# only do detection if not already set:
if [ -n "$CTDB_INIT_STYLE" ] ; then
return
fi
if [ -x /sbin/startproc ]; then
CTDB_INIT_STYLE="suse"
elif [ -x /sbin/start-stop-daemon ]; then
CTDB_INIT_STYLE="debian"
else
CTDB_INIT_STYLE="redhat"
fi
2009-01-16 13:26:57 +01:00
}
2007-06-01 20:54:26 +10:00
2007-06-02 18:51:05 +10:00
######################################################
# simulate /sbin/service on platforms that don't have it
2011-06-07 15:57:29 +10:00
# _service() makes it easier to hook the service() function for
# testing.
_service ()
{
2009-11-13 18:28:25 +11:00
_service_name="$1"
_op="$2"
2009-01-16 13:31:02 +01:00
# do nothing, when no service was specified
2009-11-20 16:45:36 +11:00
[ -z "$_service_name" ] && return
2009-01-16 13:31:02 +01:00
2007-06-02 18:51:05 +10:00
if [ -x /sbin/service ]; then
2011-06-07 15:57:29 +10:00
$_nice /sbin/service "$_service_name" "$_op"
2014-12-01 12:21:16 +11:00
elif [ -x /usr/sbin/service ]; then
$_nice /usr/sbin/service "$_service_name" "$_op"
2016-05-11 02:42:40 +10:00
elif [ -x /bin/systemctl ]; then
$_nice /bin/systemctl "$_op" "$_service_name"
2016-06-29 18:11:44 +10:00
elif [ -x "${CTDB_SYS_ETCDIR}/init.d/${_service_name}" ]; then
$_nice "${CTDB_SYS_ETCDIR}/init.d/${_service_name}" "$_op"
elif [ -x "${CTDB_SYS_ETCDIR}/rc.d/init.d/${_service_name}" ]; then
$_nice "${CTDB_SYS_ETCDIR}/rc.d/init.d/${_service_name}" "$_op"
2007-06-02 18:51:05 +10:00
fi
}
2011-06-07 15:57:29 +10:00
service()
{
_nice=""
_service "$@"
}
2008-02-13 08:20:20 +11:00
######################################################
# simulate /sbin/service (niced) on platforms that don't have it
2011-06-07 15:57:29 +10:00
nice_service()
{
_nice="nice"
_service "$@"
2008-02-13 08:20:20 +11:00
}
2007-06-17 11:57:42 +10:00
2015-04-17 20:44:15 +10:00
######################################################
# Cached retrieval of PNN from local node. This never changes so why
# open a client connection to the server each time this is needed?
ctdb_get_pnn ()
{
2015-08-13 15:54:20 +10:00
_pnn_file="${CTDB_SCRIPT_VARDIR}/my-pnn"
2015-04-17 20:44:15 +10:00
if [ ! -f "$_pnn_file" ] ; then
2016-07-22 16:19:23 +10:00
$CTDB pnn >"$_pnn_file"
2015-04-17 20:44:15 +10:00
fi
2016-07-06 17:41:55 +10:00
cat "$_pnn_file"
2015-04-17 20:44:15 +10:00
}
2016-04-08 15:53:47 +10:00
# Cached retrieval of private IP address from local node. This never
2016-07-06 17:41:55 +10:00
# changes.
2016-04-08 15:53:47 +10:00
ctdb_get_ip_address ()
{
_ip_addr_file="${CTDB_SCRIPT_VARDIR}/my-ip-address"
if [ ! -f "$_ip_addr_file" ] ; then
2016-06-08 12:28:36 +02:00
$CTDB -X nodestatus |
2016-04-08 15:53:47 +10:00
awk -F '|' 'NR == 2 { print $3 }' >"$_ip_addr_file"
fi
2016-07-06 17:16:44 +10:00
# ip_address is used by caller
# shellcheck disable=SC2034
2016-07-06 17:41:55 +10:00
cat "$_ip_addr_file"
2016-04-08 15:53:47 +10:00
}
2018-04-20 12:12:44 +10:00
# Cached retrieval of database options for use by event scripts.
#
# If the variables are already set then they should not be overwritten
# - this should only happen during event script testing.
ctdb_get_db_options ()
{
_db_opts_file="${CTDB_SCRIPT_VARDIR}/db_options.cache"
if [ ! -f "$_db_opts_file" ] ; then
{
ctdb_translate_option "database" \
"volatile database directory" \
"CTDB_DBDIR"
ctdb_translate_option "database" \
"persistent database directory" \
"CTDB_DBDIR_PERSISTENT"
ctdb_translate_option "database" \
"state database directory" \
"CTDB_DBDIR_STATE"
} >"$_db_opts_file"
fi
. "$_db_opts_file"
}
ctdb_translate_option ()
{
_section="$1"
_opt="$2"
_variable="$3"
# ctdb-config already prints an error if something goes wrong
_t=$("${CTDB_HELPER_BINDIR}/ctdb-config" get "$_section" "$_opt") || \
exit $?
echo "${_variable}=\"${_t}\""
}
2011-06-28 14:54:33 +10:00
######################################################
# wrapper around /proc/ settings to allow them to be hooked
# for testing
# 1st arg is relative path under /proc/, 2nd arg is value to set
set_proc ()
{
echo "$2" >"/proc/$1"
}
2015-06-24 21:06:22 +10:00
set_proc_maybe ()
{
if [ -w "/proc/$1" ] ; then
set_proc "$1" "$2"
fi
}
2011-06-28 14:54:33 +10:00
######################################################
# wrapper around getting file contents from /proc/ to allow
# this to be hooked for testing
# 1st arg is relative path under /proc/
get_proc ()
{
cat "/proc/$1"
}
2014-11-14 13:31:03 +11:00
######################################################
# Print up to $_max kernel stack traces for processes named $_program
program_stack_traces ()
{
_prog="$1"
_max="${2:-1}"
_count=1
for _pid in $(pidof "$_prog") ; do
2016-07-06 17:31:51 +10:00
[ "$_count" -le "$_max" ] || break
2014-11-14 13:31:03 +11:00
# Do this first to avoid racing with process exit
_stack=$(get_proc "${_pid}/stack" 2>/dev/null)
if [ -n "$_stack" ] ; then
echo "Stack trace for ${_prog}[${_pid}]:"
echo "$_stack"
2016-07-06 16:50:30 +10:00
_count=$((_count + 1))
2014-11-14 13:31:03 +11:00
fi
done
2013-08-02 16:05:46 +10:00
}
2013-04-30 03:45:21 +10:00
######################################################
# Ensure $service_name is set
assert_service_name ()
{
2018-02-06 11:25:56 +11:00
# service_name is set by the event script
# shellcheck disable=SC2154
[ -n "$service_name" ] || die "INTERNAL ERROR: \$service_name not set"
2013-04-30 03:45:21 +10:00
}
2007-06-06 12:08:42 +10:00
######################################################
# check a set of directories is available
2009-10-12 16:32:49 +11:00
# return 1 on a missing directory
2013-04-30 03:48:51 +10:00
# directories are read from stdin
2007-06-06 12:08:42 +10:00
######################################################
2013-04-30 03:48:51 +10:00
ctdb_check_directories_probe()
{
2009-11-20 16:45:36 +11:00
while IFS="" read d ; do
case "$d" in
*%*)
continue
;;
*)
2010-03-26 16:40:00 +01:00
[ -d "${d}/." ] || return 1
2009-11-20 16:45:36 +11:00
esac
done
2008-07-23 15:35:46 +10:00
}
######################################################
# check a set of directories is available
2013-04-30 03:48:51 +10:00
# directories are read from stdin
2008-07-23 15:35:46 +10:00
######################################################
2013-04-30 03:48:51 +10:00
ctdb_check_directories()
{
2009-11-20 16:45:36 +11:00
ctdb_check_directories_probe || {
2013-04-30 03:48:51 +10:00
echo "ERROR: $service_name directory \"$d\" not available"
2009-11-20 16:45:36 +11:00
exit 1
}
2007-06-06 12:08:42 +10:00
}
######################################################
# check a set of tcp ports
2009-11-20 16:45:36 +11:00
# usage: ctdb_check_tcp_ports <ports...>
2007-06-06 12:08:42 +10:00
######################################################
2011-08-05 16:39:57 +10:00
2013-10-17 15:23:35 +11:00
# Check whether something is listening on all of the given TCP ports
# using the "ctdb checktcpport" command.
2011-07-05 11:32:06 +10:00
ctdb_check_tcp_ports()
{
2016-12-17 22:40:05 +11:00
if [ -z "$1" ] ; then
echo "INTERNAL ERROR: ctdb_check_tcp_ports - no ports specified"
exit 1
fi
2011-08-17 14:02:45 +10:00
2016-12-17 22:40:05 +11:00
for _p ; do # process each function argument (port)
_cmd="$CTDB checktcpport $_p"
_out=$($_cmd 2>&1)
_ret=$?
case "$_ret" in
0)
echo "$service_name not listening on TCP port $_p"
return 1
;;
98)
# Couldn't bind, something already listening, next port
continue
;;
*)
echo "unexpected error (${_ret}) running \"${_cmd}\""
if [ -n "$_out" ] ; then
echo "$_out"
fi
return $_ret
;;
esac
done
# All ports listening
return 0
2011-08-17 14:02:45 +10:00
}
2009-05-19 08:47:19 +10:00
######################################################
# check a unix socket
2017-03-18 21:53:06 +11:00
# usage: ctdb_check_unix_socket SOCKPATH
2009-05-19 08:47:19 +10:00
######################################################
2017-03-18 21:53:06 +11:00
ctdb_check_unix_socket()
{
_sockpath="$1"
2009-05-19 08:47:19 +10:00
2017-03-18 21:53:06 +11:00
if [ -z "$_sockpath" ] ; then
echo "ERROR: ctdb_check_unix_socket() requires socket path"
return 1
fi
2017-03-18 21:55:04 +11:00
_out=$(ss -l -x "src ${_sockpath}" | tail -n +2)
if [ -z "$_out" ] ; then
2017-03-18 21:53:06 +11:00
echo "ERROR: ${service_name} not listening on ${_sockpath}"
return 1
fi
2009-05-19 08:47:19 +10:00
}
2007-10-11 07:27:38 +10:00
################################################
# kill off any TCP connections with the given IP
################################################
2013-05-06 16:23:25 +10:00
kill_tcp_connections ()
{
2016-03-11 15:27:10 +11:00
_iface="$1"
_ip="$2"
2013-04-30 06:19:18 +10:00
_oneway=false
2016-03-11 15:27:10 +11:00
if [ "$3" = "oneway" ] ; then
2013-04-30 06:19:18 +10:00
_oneway=true
fi
2013-05-06 16:23:25 +10:00
get_tcp_connections_for_ip "$_ip" | {
_killcount=0
2013-07-25 13:40:43 +10:00
_connections=""
_nl="
"
while read _dst _src; do
_destport="${_dst##*:}"
2013-04-30 06:25:26 +10:00
__oneway=$_oneway
case $_destport in
# we only do one-way killtcp for CIFS
139|445) __oneway=true ;;
esac
2013-07-25 13:40:43 +10:00
_connections="${_connections}${_nl}${_src} ${_dst}"
2013-04-30 06:25:26 +10:00
if ! $__oneway ; then
2013-07-25 13:40:43 +10:00
_connections="${_connections}${_nl}${_dst} ${_src}"
2013-04-30 06:25:26 +10:00
fi
2008-08-20 09:47:00 +10:00
2016-07-06 16:50:30 +10:00
_killcount=$((_killcount + 1))
2013-04-30 06:25:26 +10:00
done
2013-05-06 16:23:25 +10:00
if [ $_killcount -eq 0 ] ; then
return
fi
2013-04-30 11:39:46 +10:00
2016-03-11 15:30:47 +11:00
echo "$_connections" | \
"${CTDB_HELPER_BINDIR}/ctdb_killtcp" "$_iface" || {
echo "Failed to kill TCP connections"
return
2013-07-25 13:40:43 +10:00
}
2017-06-09 14:34:56 +10:00
_connections=$(get_tcp_connections_for_ip "$_ip")
if [ -z "$_connections" ] ; then
_remaining=0
else
_remaining=$(echo "$_connections" | wc -l)
2016-03-11 15:30:47 +11:00
fi
2013-04-30 11:39:46 +10:00
2017-06-09 14:34:56 +10:00
_actually_killed=$((_killcount - _remaining))
_t="${_actually_killed}/${_killcount}"
echo "Killed ${_t} TCP connections to released IP $_ip"
if [ -n "$_connections" ] ; then
echo "Remaining connections:"
echo "$_connections" | sed -e 's|^| |'
fi
2013-04-30 06:25:26 +10:00
}
2009-03-24 14:05:31 +11:00
}
##################################################################
# kill off the local end for any TCP connections with the given IP
##################################################################
2013-05-06 16:23:25 +10:00
kill_tcp_connections_local_only ()
2013-04-30 06:19:18 +10:00
{
2016-03-11 15:27:10 +11:00
kill_tcp_connections "$@" "oneway"
2007-10-11 07:27:38 +10:00
}
2009-12-18 09:43:20 +01:00
##################################################################
# tickle any TCP connections with the given IP
##################################################################
2013-05-06 16:23:25 +10:00
tickle_tcp_connections ()
{
_ip="$1"
2009-12-18 09:43:20 +01:00
2015-09-08 11:29:25 +10:00
# Get connections, both directions
_conns=$(get_tcp_connections_for_ip "$_ip" | \
awk '{ print $1, $2 ; print $2, $1 }')
2013-04-30 06:25:26 +10:00
2015-09-08 11:29:25 +10:00
echo "$_conns" | awk '{ print "Tickle TCP connection", $1, $2 }'
echo "$_conns" | ctdb tickle
2009-12-18 09:43:20 +01:00
}
2013-04-30 06:25:26 +10:00
get_tcp_connections_for_ip ()
{
_ip="$1"
2015-08-27 13:22:49 +10:00
ss -tn state established "src [$_ip]" | awk 'NR > 1 {print $3, $4}'
2013-04-30 06:25:26 +10:00
}
2014-01-28 14:41:25 +11:00
########################################################
add_ip_to_iface ()
2010-01-20 11:10:48 +01:00
{
2012-03-07 16:18:12 +11:00
_iface=$1
_ip=$2
_maskbits=$3
2010-01-20 11:10:48 +01:00
2014-01-28 14:41:25 +11:00
# Ensure interface is up
ip link set "$_iface" up || \
die "Failed to bringup interface $_iface"
2010-01-20 11:10:48 +01:00
2014-11-20 21:58:31 +11:00
# Only need to define broadcast for IPv4
2016-06-29 20:43:18 +10:00
case "$_ip" in
2014-11-20 21:58:31 +11:00
*:*) _bcast="" ;;
*) _bcast="brd +" ;;
esac
2016-07-06 17:31:51 +10:00
# Intentionally unquoted multi-word value here
# shellcheck disable=SC2086
2014-11-20 21:58:31 +11:00
ip addr add "$_ip/$_maskbits" $_bcast dev "$_iface" || {
2014-03-14 13:14:18 +11:00
echo "Failed to add $_ip/$_maskbits on dev $_iface"
return 1
}
2014-11-21 17:33:21 +11:00
# Wait 5 seconds for IPv6 addresses to stop being tentative...
if [ -z "$_bcast" ] ; then
for _x in $(seq 1 10) ; do
ip addr show to "${_ip}/128" | grep -q "tentative" || break
sleep 0.5
done
# If the address was a duplicate then it won't be on the
# interface so flag an error.
_t=$(ip addr show to "${_ip}/128")
case "$_t" in
"")
echo "Failed to add $_ip/$_maskbits on dev $_iface"
return 1
;;
*tentative*|*dadfailed*)
echo "Failed to add $_ip/$_maskbits on dev $_iface"
ip addr del "$_ip/$_maskbits" dev "$_iface"
return 1
;;
esac
fi
2010-01-20 11:10:48 +01:00
}
delete_ip_from_iface()
{
2012-03-07 16:18:12 +11:00
_iface=$1
_ip=$2
_maskbits=$3
2014-01-28 14:41:25 +11:00
# This could be set globally for all interfaces but it is probably
# better to avoid surprises, so limit it the interfaces where CTDB
# has public IP addresses. There isn't anywhere else convenient
# to do this so just set it each time. This is much cheaper than
# remembering and re-adding secondaries.
set_proc "sys/net/ipv4/conf/${_iface}/promote_secondaries" 1
2012-03-07 16:18:12 +11:00
2014-03-14 13:14:18 +11:00
ip addr del "$_ip/$_maskbits" dev "$_iface" || {
echo "Failed to del $_ip on dev $_iface"
return 1
}
2010-02-12 09:48:01 +01:00
}
2014-12-19 14:19:32 +11:00
# If the given IP is hosted then print 2 items: maskbits and iface
2013-01-04 11:23:29 +11:00
ip_maskbits_iface ()
{
_addr="$1"
2014-11-21 14:37:54 +11:00
case "$_addr" in
2016-05-14 01:06:38 +10:00
*:*) _bits=128 ;;
*) _bits=32 ;;
2014-11-21 14:37:54 +11:00
esac
ip addr show to "${_addr}/${_bits}" 2>/dev/null | \
2016-07-06 20:09:07 +10:00
awk 'NR == 1 { iface = $2; sub(":$", "", iface) ;
sub("@.*", "", iface) }
$1 ~ /inet/ { mask = $2; sub(".*/", "", mask);
2016-05-14 01:06:38 +10:00
print mask, iface }'
2013-01-04 11:23:29 +11:00
}
drop_ip ()
{
_addr="${1%/*}" # Remove optional maskbits
2016-07-06 17:31:51 +10:00
# Intentional word splitting here
# shellcheck disable=SC2046
2016-06-29 18:11:44 +10:00
set -- $(ip_maskbits_iface "$_addr")
2013-01-04 11:23:29 +11:00
if [ -n "$1" ] ; then
_maskbits="$1"
_iface="$2"
2013-06-16 20:24:10 +10:00
echo "Removing public address $_addr/$_maskbits from device $_iface"
2016-06-29 18:11:44 +10:00
delete_ip_from_iface "$_iface" "$_addr" "$_maskbits" >/dev/null 2>&1
2013-01-04 11:23:29 +11:00
fi
}
drop_all_public_ips ()
{
2016-07-06 17:16:44 +10:00
# _x is intentionally ignored
# shellcheck disable=SC2034
while read _ip _x ; do
drop_ip "$_ip"
2018-03-08 15:11:51 +11:00
done <"${CTDB_BASE}/public_addresses"
2013-01-03 15:07:07 +11:00
}
2014-11-21 14:46:00 +11:00
flush_route_cache ()
{
2015-06-24 21:06:22 +10:00
set_proc_maybe sys/net/ipv4/route/flush 1
set_proc_maybe sys/net/ipv6/route/flush 1
2014-11-21 14:46:00 +11:00
}
2015-12-18 15:43:33 +11:00
########################################################
# Interface monitoring
# If the interface is a virtual one (e.g. VLAN) then get the
# underlying interface
interface_get_real ()
{
# Output of "ip link show <iface>"
_iface_info="$1"
# Extract the full interface description to see if it is a VLAN
_t=$(echo "$_iface_info" |
2016-07-06 20:09:07 +10:00
awk 'NR == 1 { iface = $2; sub(":$", "", iface) ;
2015-12-18 15:43:33 +11:00
print iface }')
case "$_t" in
*@*)
# VLAN: use the underlying interface, after the '@'
echo "${_t##*@}"
;;
*)
# Not a regular VLAN. For backward compatibility, assume
# there is some other sort of VLAN that doesn't have the
# '@' in the output and only use what is before a '.'. If
# there is no '.' then this will be the whole interface
# name.
echo "${_t%%.*}"
esac
}
# Check whether an interface is operational
interface_monitor ()
{
_iface="$1"
_iface_info=$(ip link show "$_iface" 2>&1) || {
echo "ERROR: Monitored interface ${_iface} does not exist"
return 1
}
# If the interface is a virtual one (e.g. VLAN) then get the
# underlying interface.
_realiface=$(interface_get_real "$_iface_info")
if _bi=$(get_proc "net/bonding/${_realiface}" 2>/dev/null) ; then
# This is a bond: various monitoring strategies
echo "$_bi" | grep -q 'Currently Active Slave: None' && {
echo "ERROR: No active slaves for bond device ${_realiface}"
return 1
}
echo "$_bi" | grep -q '^MII Status: up' || {
echo "ERROR: public network interface ${_realiface} is down"
return 1
}
echo "$_bi" | grep -q '^Bonding Mode: IEEE 802.3ad Dynamic link aggregation' && {
# This works around a bug in the driver where the
# overall bond status can be up but none of the actual
# physical interfaces have a link.
echo "$_bi" | grep 'MII Status:' | tail -n +2 | grep -q '^MII Status: up' || {
echo "ERROR: No active slaves for 802.ad bond device ${_realiface}"
return 1
}
}
return 0
else
# Not a bond
case "$_iface" in
lo*)
# loopback is always working
return 0
;;
ib*)
# we don't know how to test ib links
return 0
;;
*)
ethtool "$_iface" | grep -q 'Link detected: yes' || {
# On some systems, this is not successful when a
# cable is plugged but the interface has not been
# brought up previously. Bring the interface up
# and try again...
ip link set "$_iface" up
ethtool "$_iface" | grep -q 'Link detected: yes' || {
echo "ERROR: No link on the public network interface ${_iface}"
return 1
}
}
return 0
;;
esac
fi
}
2009-09-30 21:05:16 +10:00
########################################################
2013-08-02 15:18:47 +10:00
# Simple counters
2018-02-06 13:51:23 +11:00
_ctdb_counter_common ()
{
[ $# -le 1 ] || die "usage: _ctdb_counter_common [name]"
if [ $# -eq 1 ] ; then
_counter_name="${1}.failcount"
else
_counter_name="failcount"
fi
if [ -z "$script_state_dir" ] ; then
die "ctdb_counter_* functions need ctdb_setup_state_dir()"
fi
_counter_file="${script_state_dir}/${_counter_name}"
2009-09-30 21:05:16 +10:00
}
2016-07-06 20:25:57 +10:00
# Some code passes an argument
# shellcheck disable=SC2120
2009-09-30 21:05:16 +10:00
ctdb_counter_init () {
2010-12-16 10:11:33 +11:00
_ctdb_counter_common "$1"
2009-09-30 21:05:16 +10:00
2017-07-13 12:52:39 +10:00
: >"$_counter_file"
2009-09-30 21:05:16 +10:00
}
ctdb_counter_incr () {
2010-12-16 10:11:33 +11:00
_ctdb_counter_common "$1"
2009-09-30 21:05:16 +10:00
2016-07-07 06:41:27 +10:00
# unary counting using newlines!
echo >>"$_counter_file"
2009-09-30 21:05:16 +10:00
}
2015-07-11 11:02:54 +10:00
ctdb_counter_get () {
_ctdb_counter_common "$1"
# unary counting!
stat -c "%s" "$_counter_file" 2>/dev/null || echo 0
}
2010-11-17 13:50:56 +11:00
2009-11-13 18:28:25 +11:00
########################################################
2018-02-06 13:49:46 +11:00
# ctdb_setup_state_dir <type> <name>
# Sets/creates script_state_dir)
ctdb_setup_state_dir ()
{
[ $# -eq 2 ] || die "usage: ctdb_setup_state_dir <type> <name>"
_type="$1"
_name="$2"
script_state_dir="${CTDB_SCRIPT_VARDIR}/${_type}/${_name}"
mkdir -p "$script_state_dir" || \
die "Error creating script state dir \"${script_state_dir}\""
}
2010-12-15 19:19:21 +11:00
##################################################################
# Reconfigure a service on demand
_ctdb_service_reconfigure_common ()
{
2018-02-06 13:50:47 +11:00
if [ -z "$script_state_dir" ] ; then
die "ctdb_service_*_reconfigure() needs ctdb_setup_state_dir()"
fi
_ctdb_service_reconfigure_flag="${script_state_dir}/need_reconfigure"
2010-12-15 19:19:21 +11:00
}
2009-11-13 18:28:25 +11:00
ctdb_service_needs_reconfigure ()
{
2013-04-30 02:59:41 +10:00
_ctdb_service_reconfigure_common
2010-12-15 19:19:21 +11:00
[ -e "$_ctdb_service_reconfigure_flag" ]
2009-09-30 21:05:16 +10:00
}
2009-11-13 18:28:25 +11:00
ctdb_service_set_reconfigure ()
{
2013-04-30 02:59:41 +10:00
_ctdb_service_reconfigure_common
2017-07-13 12:52:39 +10:00
: >"$_ctdb_service_reconfigure_flag"
2009-11-13 18:28:25 +11:00
}
ctdb_service_unset_reconfigure ()
{
2013-04-30 02:59:41 +10:00
_ctdb_service_reconfigure_common
2010-12-15 19:19:21 +11:00
rm -f "$_ctdb_service_reconfigure_flag"
2009-11-13 18:28:25 +11:00
}
ctdb_service_reconfigure ()
{
2013-04-30 02:59:41 +10:00
echo "Reconfiguring service \"${service_name}\"..."
ctdb_service_unset_reconfigure
service_reconfigure || return $?
2016-07-06 20:25:57 +10:00
# Intentionally have this use $service_name as default
# shellcheck disable=SC2119
2013-04-30 02:59:41 +10:00
ctdb_counter_init
2010-12-15 19:19:21 +11:00
}
2012-12-04 15:00:44 +11:00
# Default service_reconfigure() function does nothing.
2010-12-15 19:19:21 +11:00
service_reconfigure ()
{
2012-12-04 15:00:44 +11:00
:
2010-12-15 19:19:21 +11:00
}
2011-08-11 09:39:25 +10:00
# Default service_start() and service_stop() functions.
2018-03-22 15:52:05 +11:00
2014-02-14 16:59:08 +11:00
# These may be overridden in an eventscript.
2011-08-11 09:39:25 +10:00
service_start ()
{
2013-04-30 03:18:01 +10:00
service "$service_name" start
2011-08-11 09:39:25 +10:00
}
service_stop ()
{
2013-04-30 03:18:01 +10:00
service "$service_name" stop
2009-11-13 18:28:25 +11:00
}
2011-08-11 09:39:25 +10:00
##################################################################
2016-07-11 15:04:16 +10:00
# This exists only for backward compatibility with 3rd party scripts
# that call it
2009-12-01 17:43:47 +11:00
ctdb_standard_event_handler ()
{
2015-08-10 16:03:05 +10:00
:
2009-12-01 17:43:47 +11:00
}
2014-11-21 14:39:43 +11:00
iptables_wrapper ()
{
_family="$1" ; shift
if [ "$_family" = "inet6" ] ; then
2014-12-30 16:04:00 +11:00
_iptables_cmd="ip6tables"
2014-11-21 14:39:43 +11:00
else
2014-12-30 16:04:00 +11:00
_iptables_cmd="iptables"
2014-11-21 14:39:43 +11:00
fi
2014-12-30 16:04:00 +11:00
# iptables doesn't like being re-entered, so flock-wrap it.
2015-08-13 15:57:52 +10:00
flock -w 30 "${CTDB_SCRIPT_VARDIR}/iptables.flock" "$_iptables_cmd" "$@"
2014-11-21 14:39:43 +11:00
}
2010-07-12 15:11:42 +09:30
2013-05-25 19:57:24 +10:00
# AIX (and perhaps others?) doesn't have mktemp
2016-07-06 20:43:29 +10:00
# type is commonly supported and more portable than which(1)
# shellcheck disable=SC2039
2015-06-05 09:20:59 -05:00
if ! type mktemp >/dev/null 2>&1 ; then
2013-05-25 19:57:24 +10:00
mktemp ()
{
_dir=false
if [ "$1" = "-d" ] ; then
_dir=true
shift
fi
_d="${TMPDIR:-/tmp}"
_hex10=$(dd if=/dev/urandom count=20 2>/dev/null | \
md5sum | \
sed -e 's@\(..........\).*@\1@')
_t="${_d}/tmp.${_hex10}"
(
umask 077
if $_dir ; then
mkdir "$_t"
else
2017-07-13 12:52:39 +10:00
: >"$_t"
2013-05-25 19:57:24 +10:00
fi
)
echo "$_t"
}
fi
2016-06-06 13:56:55 +10:00
######################################################################
# NFS callout handling
nfs_callout_init ()
{
2016-07-06 17:41:55 +10:00
_state_dir="$1"
2016-06-06 13:56:55 +10:00
if [ -z "$CTDB_NFS_CALLOUT" ] ; then
CTDB_NFS_CALLOUT="${CTDB_BASE}/nfs-linux-kernel-callout"
fi
# Always export, for statd callout
export CTDB_NFS_CALLOUT
# If the callout wants to use this then it must create it
2016-07-06 17:41:55 +10:00
export CTDB_NFS_CALLOUT_STATE_DIR="${_state_dir}/callout-state"
2016-06-06 13:56:55 +10:00
# Export, if set, for use by clustered NFS callouts
if [ -n "$CTDB_NFS_STATE_FS_TYPE" ] ; then
export CTDB_NFS_STATE_FS_TYPE
fi
if [ -n "$CTDB_NFS_STATE_MNT" ] ; then
export CTDB_NFS_STATE_MNT
fi
2016-07-06 17:41:55 +10:00
nfs_callout_cache="${_state_dir}/nfs_callout_cache"
2016-06-06 13:56:55 +10:00
nfs_callout_cache_callout="${nfs_callout_cache}/CTDB_NFS_CALLOUT"
nfs_callout_cache_ops="${nfs_callout_cache}/ops"
}
nfs_callout_register ()
{
mkdir -p "$nfs_callout_cache_ops"
rm -f "$nfs_callout_cache_ops"/*
echo "$CTDB_NFS_CALLOUT" >"$nfs_callout_cache_callout"
_t=$(eval "$CTDB_NFS_CALLOUT" "register")
if [ -n "$_t" ] ; then
echo "$_t" |
while IFS="" read _op ; do
touch "${nfs_callout_cache_ops}/${_op}"
done
else
touch "${nfs_callout_cache_ops}/ALL"
fi
}
nfs_callout ()
{
# Re-run registration if $CTDB_NFS_CALLOUT has changed
_prev=""
if [ -r "$nfs_callout_cache_callout" ] ; then
read _prev <"$nfs_callout_cache_callout"
fi
if [ "$CTDB_NFS_CALLOUT" != "$_prev" ] ; then
nfs_callout_register
fi
# Run the operation if it is registered...
if [ -e "${nfs_callout_cache_ops}/${1}" ] || \
[ -e "${nfs_callout_cache_ops}/ALL" ]; then
eval "$CTDB_NFS_CALLOUT" "$@"
fi
}
2010-08-26 14:59:59 +10:00
########################################################
# tickle handling
########################################################
update_tickles ()
{
_port="$1"
2015-08-13 15:54:20 +10:00
tickledir="${CTDB_SCRIPT_VARDIR}/tickles"
2013-04-17 13:26:04 +10:00
mkdir -p "$tickledir"
2010-08-26 14:59:59 +10:00
# What public IPs do I hold?
2016-07-06 17:41:55 +10:00
_pnn=$(ctdb_get_pnn)
_ips=$($CTDB -X ip | awk -F'|' -v pnn="$_pnn" '$3 == pnn {print $2}')
2010-08-26 14:59:59 +10:00
2015-08-27 13:22:49 +10:00
# IPs and port as ss filters
_ip_filter=""
for _ip in $_ips ; do
_ip_filter="${_ip_filter}${_ip_filter:+ || }src [${_ip}]"
done
_port_filter="sport == :${_port}"
2010-08-26 14:59:59 +10:00
2015-12-10 15:03:46 +11:00
# Record connections to our public IPs in a temporary file.
# This temporary file is in CTDB's private state directory and
# $$ is used to avoid a very rare race involving CTDB's script
# debugging. No security issue, nothing to see here...
_my_connections="${tickledir}/${_port}.connections.$$"
2015-08-27 13:22:49 +10:00
# Parentheses are needed around the filters for precedence but
# the parentheses can't be empty!
ss -tn state established \
"${_ip_filter:+( ${_ip_filter} )}" \
"${_port_filter:+( ${_port_filter} )}" |
awk 'NR > 1 {print $4, $3}' |
2010-08-26 14:59:59 +10:00
sort >"$_my_connections"
# Record our current tickles in a temporary file
2015-12-10 15:03:46 +11:00
_my_tickles="${tickledir}/${_port}.tickles.$$"
2010-08-26 14:59:59 +10:00
for _i in $_ips ; do
2016-06-29 18:11:44 +10:00
$CTDB -X gettickles "$_i" "$_port" |
2014-11-20 14:32:46 +11:00
awk -F'|' 'NR > 1 { printf "%s:%s %s:%s\n", $2, $3, $4, $5 }'
2010-08-26 14:59:59 +10:00
done |
sort >"$_my_tickles"
# Add tickles for connections that we haven't already got tickles for
2015-03-23 19:37:35 +11:00
comm -23 "$_my_connections" "$_my_tickles" | \
$CTDB addtickle
2010-08-26 14:59:59 +10:00
# Remove tickles for connections that are no longer there
2015-03-23 19:37:35 +11:00
comm -13 "$_my_connections" "$_my_tickles" | \
$CTDB deltickle
2010-08-26 14:59:59 +10:00
2015-12-10 15:03:46 +11:00
rm -f "$_my_connections" "$_my_tickles"
# Remove stale files from killed scripts
2016-07-12 13:27:08 +10:00
# Files can't have spaces in name, more portable than -print0/-0
# shellcheck disable=SC2038
(cd "$tickledir" && find . -type f -mmin +10 | xargs -r rm)
2010-08-26 14:59:59 +10:00
}
2008-04-10 06:50:12 +10:00
########################################################
# load a site local config file
########################################################
2016-06-29 18:11:44 +10:00
[ -x "${CTDB_BASE}/rc.local" ] && {
. "${CTDB_BASE}/rc.local"
2008-04-10 06:50:12 +10:00
}
2008-08-20 09:47:00 +10:00
2016-06-29 18:11:44 +10:00
[ -d "${CTDB_BASE}/rc.local.d" ] && {
for i in "${CTDB_BASE}/rc.local.d"/* ; do
2009-10-19 16:22:15 +11:00
[ -x "$i" ] && . "$i"
done
}
2009-12-01 17:43:47 +11:00
script_name="${0##*/}" # basename